/*				rdbuf				*/

int rdbuf(ibuf,ie1,ie2,ie3,tmo)
char ibuf[],ie1,ie2,ie3;
int tmo;
{
/*
	this subroutine reads characters from the serial line
	defined by global cmport (0=com1, 1=com2) and stores
	them in ibuf.  the operation
	continues until any one of the three line terminators
	ie1, ie2 or ie3 is found.  the operation also ends on
	the 280th character if no line terminator is found.
	the input line is terminated by a zero byte; the last
	character before the zero byte is the terminator.

	the parameter tmo is a time-out count.  if no character is
	received before tmo goes to zero, the subroutine returns with
	a count of zero (a time-out on a partial line will result in
	the line being thrown away).
*/
#include <stdio.h>
#include <dos.h>
int j,tcount;
unsigned char stat,mstat;
int tlimit = -16000;
char cc;
extern int cmport;
extern union REGS inregs,outregs;

	tcount= tlimit;
	j=0;
	do
	{
	   do
	   {
/*
	loop until character is available or tcount goes to 0.
*/
/*
	   _AH=3;
	   _DX=cmport;
	   geninterrupt(0x14);
	   stat=_AH;
	   mstat=_AL;
*/
		inregs.h.ah = 0x3;	/* comm port status req */
		inregs.x.dx = cmport;
		int86(0x14,&inregs,&outregs);
		stat = outregs.h.ah;
		mstat = outregs.h.al;

	   tcount++;
	   }  while ( (tcount < 0) && ( (stat & 1) ==0) );
	if(tcount == 0)
	   {
	   tmo++;
	   if(tmo == 0) return(0);
	   }
	else
	   {
/*
	   _AH=2;
	   _DX=cmport;
	   geninterrupt(0x14);
	   cc=_AL;
*/
		inregs.h.ah = 0x2;	/* read char from comm port */
		inregs.x.dx = cmport;
		int86(0x14,&inregs,&outregs);
		cc = outregs.h.al;

	   ibuf[j]=cc & 0x7f;    /* turn off ms bit */
	   j++;
/*
	if clear to send and carrier detect have been lost then
	the fact that a character is ready to be read is an error
	how can characters be ready over and over again
	the BIOS does this ??
*/
	   if( (mstat && 0xb0) == 0) return(0);
	   }
	tcount=tlimit;
	} while ( (j < 280) && (cc != ie1) && (cc != ie2) && (cc != ie3) );
	ibuf[j]=0;
	return(j);
}
